// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'starter.controllers',  'starter.services', 'LocalStorageModule', 'ngResource', 'ajoslin.promise-tracker','starter.filters','ngCordova'])

.directive('errSrc', function() {
  return {
    link: function(scope, element, attrs) {
      element.bind('error', function() {
        if (attrs.src != attrs.errSrc) {
          attrs.$set('src', attrs.errSrc);
        }
      });
    }
  }
})

.run(function($http, apihost, $ionicPlatform,$rootScope,localStorageService,$location,Mystats,$cordovaDevice, $cordovaAppVersion, $cordovaAppRate,$cordovaPush,transformRequestAsFormPost) {
  var androidConfig = {
    "senderID": "640316693850",
  };
  $rootScope.getFbId = function(){
    return localStorageService.get('fb_id');
  },
  $rootScope.$watch('fb_id', function(newValue, oldValue) {    
    if( $rootScope.fb_id) {      
      $rootScope.getMystats();
    }
  });
  $rootScope.getMystats = function(){ 
    console.log('fetch stats for ' + localStorageService.get('fb_id'));
    Mystats.get ({user_id:localStorageService.get('fb_id'),access_token:localStorageService.get('access_token'),'name':localStorageService.get('name'),'email':localStorageService.get('email'),'password':localStorageService.get('password'),'uuid': localStorageService.get('uuid')},
      function( result ) {               
        $rootScope.bids = result.bids;        
        $rootScope.userCash = result.userCash;
        $rootScope.bankLoan= result.bankLoan;
        $rootScope.bankBalance = result.bankBalance;
        $rootScope.availableLoan = result.availableLoan;
        $rootScope.level = result.level;
        $rootScope.thisLevel = result.thisLevel;
        $rootScope.nextLevel = result.nextLevel;
        $rootScope.uid = result.uid;
        $rootScope.refcode = result.refcode;
        $rootScope.name = result.name;
        localStorageService.set('fb_id',result.uid);
        localStorageService.set('refcode',result.refcode);
        localStorageService.set('name',result.name);                
        var device = localStorageService.get('device');        
        $http({url:apihost+"/gcm_users/add", method: "POST", transformRequest: transformRequestAsFormPost, headers: {'Content-Type': 'application/x-www-form-urlencoded;charset=utf-8'}, data: { 'gcm_regid' : localStorageService.get('gcmid'), 'user_id' : result.uid,'device': JSON.stringify(device), 'appversion': localStorageService.get('appversion')}}).
          success(function(data, status, headers, config) {
            // $ionicLoading.hide();           
          }).
          error(function(data, status, headers, config) {
            // $ionicLoading.hide();
          });
      },
      function( error ) {
        console.log( "Something went wrong!" );
      }
    );
  }, 
  $rootScope.fbLoggedIn = function() {
    if(localStorageService.get('fb_id'))
      return true;
    return false;
  },
  $rootScope.logout = function(){
    localStorageService.clearAll();
    $location.path('/app/playlists');
  },
  $rootScope.compareTime = function(dateString, now, timeout) {
    console.log((now - dateString)/1000);
    return((now - dateString)/1000>timeout);
  }
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }
  });
  document.addEventListener("deviceready", function(){
    var device = $cordovaDevice.getDevice();
    localStorageService.set('device',device);    
    $cordovaAppVersion.getAppVersion().then(function (version) {
      var appVersion = version;
      localStorageService.set('appversion',appVersion);
    });
    $cordovaPush.register(androidConfig).then(function(result) {
      // Success
    }, function(err) {
      // Error
    })

    $rootScope.$on('$cordovaPush:notificationReceived', function(event, notification) {
      switch(notification.event) {
        case 'registered':
          if (notification.regid.length > 0 ) {
            // alert('registration ID = ' + notification.regid);
            localStorageService.set('gcmid', notification.regid);
            // var url = 'http://api.snapchum.com/gcm/register.php?regid='+notification.regid+'&callback=?';
          }
          break;

        case 'message':
          if(notification.payload.type == 'update'){
            try{
              document.addEventListener("deviceready", function () {
                $cordovaAppRate.navigateToAppStore().then(function (result) {
                    // success
                });
              }, false);
            } catch(err) {
              console.log(err);
            }
          } else if(notification.payload.type == 'url') {
            var ref = window.open(notification.payload.url, '_blank', 'location=yes');   
          }
          // this is the actual push notification. its format depends on the data model from the push server
          try{
            app.TrackNotificationOpened('Notification', notification.payload.message, localStorageService.get('me'), 1);
          }catch(err){
            console.log(err);
          }
          break;

        case 'error':
          // alert('GCM error = ' + notification.msg);
          break;

        default:
          // alert('An unknown GCM event has occurred');
          break;
      }
    });

  }, false);
})

.config(function($stateProvider, $urlRouterProvider) {
  // openFB.init({appId: appid});
  openFB.init({appId: '860704380618102'});
  $stateProvider

  .state('app', {
    url: "/app",
    abstract: true,
    templateUrl: "templates/menu.html",
    controller: 'AppCtrl'
  })

  .state('app.search', {
    url: "/search",
    views: {
      'menuContent': {
        templateUrl: "templates/search.html",
        controller: 'BankCtrl'
      }
    }
  })

  .state('app.browse', {
    url: "/browse",
    views: {
      'menuContent': {
        templateUrl: "templates/browse.html",
        controller: 'LeadersCtrl'
      }
    }
  })

  .state('app.member', {
    url: "/leader/:id",
    views: {
      'menuContent': {
        templateUrl: "templates/member.html",
        controller: 'MemberCtrl'
      }
    }
  })
    .state('app.playlists', {
      url: "/playlists",
      views: {
        'menuContent': {
          templateUrl: "templates/playlists.html",
          controller: 'PlaylistsCtrl'
        }
      }
    })

  .state('app.profile', {
    url: "/profile",
    views: {
      'menuContent' :{
          templateUrl: "templates/profile.html",
          controller: "ProfileCtrl"
      }
    }
  })

  .state('app.userncash', {
    url: "/userncash",
    views: {
      'menuContent' :{
          templateUrl: "templates/userncash.html",
          controller: "CashCtrl"
      }
    }
  })

  .state('app.relatedbets', {
    url: "/relatedbets/:eventId",
    views: {
      'menuContent': {
        templateUrl: "templates/relatedbets.html",
        controller: 'RelatedbetsCtrl'
      }
    }
  })

   .state('app.otherbets', {
    url: "/otherbets",
    views: {
      'menuContent': {
        templateUrl: "templates/otherbets.html",
        controller: 'OtherbetsCtrl'
      }
    }
  })

  .state('app.feedback', {
    url: "/feedback",
    views: {
      'menuContent': {
        templateUrl: "templates/feedback.html",
        controller: 'FeedbackCtrl'
      }
    }
  })

  .state('app.teamstats', {
    url: "/teamstats/:eventId",
    views: {
      'menuContent': {
        templateUrl: "templates/teamstats.html",
        controller: 'TeamStatsCtrl'
      }
    }
  })

  .state('app.offerwall', {
    url: "/offerwall",
    views: {
      'menuContent': {
        templateUrl: "templates/offerwall.html",
        controller: 'OfferwallCtrl'
      }
    }
  })

  .state('app.single', {
    url: "/playlists/:eventId",
    views: {
      'menuContent': {
        templateUrl: "templates/playlist.html",
        controller: 'PlaylistCtrl'
      }
    }
  });
  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/app/playlists');
});