angular.module('starter.controllers', [])

.controller('AppCtrl', function($scope, $ionicModal, $timeout, $rootScope, localStorageService, apihost, Mystats, $window, Auth, $cordovaDevice,$cordovaSocialSharing) {
   document.addEventListener("deviceready", function () {    
    localStorageService.set('uuid', $cordovaDevice.getUUID());  
  }, false);

  // Form data for the login modal
  $scope.authMessage = '';
  $scope.teams = $window.teams;
  $scope.loginData = {};    

  $scope.shareit = function() {
    console.log('shareit');
    $cordovaSocialSharing.share("I loved playing Fantasy Betting Game. You will too. Install the app with my referral code : "+localStorageService.get('refcode'), "Dare to bet", null, "https://play.google.com/store/apps/details?id=com.mastishq.fantasybetting");
  };

  // Create the login modal that we will use later
  $ionicModal.fromTemplateUrl('templates/login.html', {
    scope: $scope
  }).then(function(modal) {
    $scope.modal = modal;
  });

  // Triggered in the login modal to close it
  $scope.closeLogin = function() {
    $scope.modal.hide();
  };

  // Open the login modal
  $scope.login = function() {
    $scope.modal.show();
  };

  $scope.authLabel = 'Login';
  $scope.dologin = false;
  $scope.inputtype = 'password';
  $scope.changeAuthType = function(dologin){
    if(dologin){
      $scope.inputtype = 'text'; 
      $scope.authLabel = 'Free Signup';     
    }else{
      $scope.inputtype = 'password';
      $scope.authLabel = 'Login';      
    }
  }
  $scope.validateEmail = function(email) { 
    var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(email);
  } 
  // Perform the login action when the user submits the login form
  $scope.doLogin = function() {
    if(!$scope.validateEmail($scope.loginData.username)) {
      $scope.authMessage = "Invalid Email";
    } 
    else if($scope.loginData.password.length < 6){
      $scope.authMessage = "Password must be atleast 6 characters long";
    } 
    else{
      $scope.authMessage = "";
      Auth.authenticate ({email: $scope.loginData.username,password: $scope.loginData.password,refcode: $scope.loginData.refcode},
        function( result ) { 
          if(!result.success){
            $scope.authMessage = result.message;  
          }else{
            try{
              app.TrackButtonClicked('nativeLogin', 'success', result.user.User.email);
              $window.mixpanel.track("login", {
                'type':'Native'
              }); 
            } catch(e){
              console.log(e.message);
            }
            if(typeof(Storage) !== "undefined") {
              localStorage.setItem('userid',result.user.User.uid);                    
            }
            $rootScope.fb_id = result.user.User.uid;
            $rootScope.uid = result.user.User.uid;
            localStorageService.set('fb_id',result.user.User.uid);
            localStorageService.set('access_token',-1);
            if(result.user.User.screenname) {
              localStorageService.set('name',result.user.User.screenname);
            }else{
              localStorageService.set('name',-1);
            }
            localStorageService.set('email',result.user.User.email);
            localStorageService.set('password',result.user.User.password);
            $rootScope.getMystats();
            $scope.$apply(function() {
              $scope.user = result.user.User;
            });
            $scope.closeLogin();
          }
        },
        function( error ) {
          $scope.authMessage = "Something went wrong. Try again later!";
        }
      );
    }
    // Simulate a login delay. Remove this and replace with your login
    // code if using a login system
    /*$timeout(function() {
      $scope.closeLogin();
    }, 1000);*/
  };

  $scope.fbLogin = function() {    
    try{
      app.TrackButtonClicked('Fblogin', 'click', 1);
      $window.mixpanel.track("login", {
        'type':'Facebook'
      }); 
    } catch(e){
      console.log(e.message);
    }
    openFB.login(
      function(response) {
          if (response.status === 'connected') {
            $rootScope.access_token = response.authResponse.token;
            localStorageService.set('access_token',response.authResponse.token);
            console.log('Facebook login succeeded');
            openFB.api({
              path: '/me',
              params: {fields: 'id,name,email'},
              success: function(user) {
                try{
                  app.TrackButtonClicked('Fblogin', 'success', user.name);
                } catch(e){
                  console.log(e.message);
                }
                if(typeof(Storage) !== "undefined") {
                  localStorage.setItem('userid',user.id);                    
                }
                $rootScope.fb_id = user.id;
                $rootScope.uid = user.id;
                localStorageService.set('fb_id',user.id);
                localStorageService.set('name',user.name);
                localStorageService.set('email',user.email);
                $rootScope.getMystats();
                $scope.$apply(function() {
                  $scope.user = user;
                });
              },
              error: function(error) {
                console.log('Facebook error: ' + error.error_description);
              }
            });
            $scope.closeLogin();
          } else {
            console.log('Facebook login failed');
          }
      },
      {scope: 'email'});
  };

  $scope.fbLoginSuccess = function (userData) {
    console.log("UserInfo: " + JSON.stringify(userData));
  };

  $scope.fbLoginSuccess = function (error) {
    console.log("Error: " + error);
  };    
})

.controller('FeedbackCtrl', function($scope,$cordovaEmailComposer) {
  $cordovaEmailComposer.isAvailable().then(function() {
   // is available
    $cordovaEmailComposer.open(email).then(null, function () {
   // user cancelled email
    });
  }, function () {
   // not available
  });

  var email = {
    to: 'imansince84@gmail.com',
    cc: 'anikendra@gmail.com',
    subject: 'Fantasy Betting Game Feedback',
    body: 'I have something to say about ... ',
    isHtml: true
  };  
  $scope.sendFeedback = function() {
    $cordovaEmailComposer.open(email).then(null, function () {
   // user cancelled email
    });
  }
})

.controller('PlaylistsCtrl', function($scope,$rootScope,localStorageService,Schedules,baseUrl,$ionicLoading,$window,$ionicPopup,Jackpot) {  
  $scope.teams = $window.teams;
  $scope.leagues = $window.leagues;
  $scope.baseUrl = baseUrl;
  $scope.maxpages = $scope.curpage = 1;
  $scope.events = [];
  $scope.odds = [];  
  var me = localStorageService.get('fb_id');

  $scope.showAlert = function() {
    Jackpot.claim({uid:me},
      function( result ) { 
          var alertPopup = $ionicPopup.alert({
           title: 'Daily Jackpot!',
           template: result.message
          });
          alertPopup.then(function(res) {
            var object = {value: 'shown', timestamp: new Date().getTime()}
            localStorageService.set('jackpot', object);
         });
      }, function( error ) {
        //some error
      }
    );  
  };

  if(me){
    $rootScope.me = me;
    var jackpot = localStorageService.get('jackpot');
    var now = new Date().getTime().toString();

    $window.mixpanel.identify(me);
        mixpanel.people.set({
        "$email": localStorageService.get('email'),    // only special properties need the $
        "fbg$": $rootScope.userCash,                    // ...or numbers
        "level": $rootScope.level,
        "bids": $rootScope.bids,
        "loan": $rootScope.bankLoan,
        "bankbalance": $rootScope.bankBalance,
        "appversion": localStorageService.get('appversion'),
        "$name": localStorageService.get('name'),
      });
    if(typeof jackpot == 'undefined' || !jackpot){
      $scope.showAlert();
    } else if(jackpot && $rootScope.compareTime(jackpot.timestamp,now,86400)){
      localStorageService.remove('jackpot');
      $scope.showAlert();
    }    
  }else{
    $rootScope.me = -1;
  }
  $scope.league_id = 99;
  $scope.loadmore = function () {   
    try{
      app.PageButtonClicked("Matches "+$scope.curpage);
      // app.addBanner();
    }catch(e){
      console.log(e.message);
    }
    $ionicLoading.show({
      template: 'Loading...'
    }); 
    Schedules.get ({page: $scope.curpage++,user_id:$rootScope.me,league_id:$scope.league_id},
      function( result ) {   
        var eventlist = localStorageService.get('eventlist');
        if(!eventlist){
          var eventlist = [];
        }
        console.log(eventlist);
        $ionicLoading.hide();                       
        $scope.events = result.matches;
        var object = {value: result.matches, timestamp: new Date().getTime()}
        localStorageService.set('matches', object);
        $scope.odds = result.matches.odds;
        for(var i in result.matches.matches) {          
          localStorageService.set('events-'+result.matches.matches[i].id,result.matches.matches[i]);
          eventlist.push(result.matches.matches[i].id);
        }        
        localStorageService.set('odds',result.matches.odds);
        localStorageService.set('eventlist',eventlist);
      },
      function( error ) {
        $ionicLoading.hide();               
        $scope.message = "Something went wrong. Try again later!";
      }
    );
    $scope.$broadcast('scroll.infiniteScrollComplete');                               
  },  
  $scope.moreDataCanBeLoaded = function() {
    if($scope.curpage <= $scope.maxpages)
      return true;
    return false;
  },
  $scope.$on('$stateChangeSuccess', function() {
    var cachedMatches = localStorageService.get('matches');
    if(typeof cachedMatches == 'undefined' || cachedMatches == null) {
      $scope.loadmore();
    } else{      
      dateString = cachedMatches.timestamp,
      now = new Date().getTime().toString();      
      $scope.events = cachedMatches.value;      
      $scope.odds = localStorageService.get('odds');
      if($rootScope.compareTime(dateString,now,90)){
        localStorageService.remove('matches');
        localStorageService.remove('eventlist');
        $scope.events = null;
        $scope.loadmore();
      }
    }
  }); 
  $scope.getLeagueName = function(){
    for(var i in $scope.leagues){      
      if(parseInt($scope.leagues[i].id) == parseInt($scope.league_id)) {
        return $scope.leagues[i].name+' Matches';
      }
    }
    return 'World Cup 2015 Matches'; 
  } 
  $scope.leagueChanged = function(selectedLeague) {
    $scope.league_id = selectedLeague;
    $scope.loadmore();
    $scope.leagueName = $scope.getLeagueName();
  }  
  $scope.leagueName = 'Choose League';  
})

.controller('PlaylistCtrl', function($scope, $stateParams, $rootScope, localStorageService, $http, baseUrl, promiseTracker,apihost,$window, $cordovaSocialSharing, $location, $state) {
  var eventlist = localStorageService.get('eventlist');
  // console.log(eventlist);
  try{
    app.PageButtonClicked("Event");
    app.addBanner();
  }catch(e){
    console.log(e.message);
  }  
  $scope.getClassName = function() {
    for(var i in $window.leagues){      
      if(parseInt($window.leagues[i].id) == parseInt($scope.leagueId)) {
        return $window.leagues[i].class;
      }
    }
  }
  $scope.teams = $window.teams;
  $scope.progress = promiseTracker();
  $scope.baseUrl = baseUrl;
  $scope.eventId = $stateParams.eventId;
  $scope.event = localStorageService.get('events-'+$stateParams.eventId);
  if(typeof $scope.event != 'undefined') {
    $scope.leagueId = $scope.event.leagueid;
  }
  $scope.odds = localStorageService.get('odds');
  // $scope.teams = localStorageService.get('teams');  
  var me = localStorageService.get('fb_id');
  if(me){
    $scope.me = me;
    if(typeof $rootScope.bids == "undefined"){
      $rootScope.getMystats();
    }
  }else{
    $scope.me = -1;
  }
  $scope.isDrawPossible = function(event) {
    if(event.draw_possible==1){
        return true;
    }
    return false;
  },
  $scope.isChecked = function(teamId) {
    if($rootScope.bids && $rootScope.bids[$scope.eventId]){
      if($rootScope.bids[$scope.eventId].team == teamId){
        return true;
      }
    }
    return false;
  },
  $scope.shareit = function() {
    var string = $scope.teams[$scope.event.team1].name+" and "+$scope.teams[$scope.event.team2].name;
    var teaser = $scope.teams[$scope.event.team1].name+" or "+$scope.teams[$scope.event.team2].name+'?';
    $cordovaSocialSharing.share("I placed a bet on the match between "+string+" in Fantasy Betting. Dare to bet?", teaser, null, "https://play.google.com/store/apps/details?id=com.mastishq.fantasybetting");
  },
  $scope.submit = function(bet) {    
    // Trigger validation flag.
    $scope.submitted = true;
    // If form is invalid, return and let AngularJS show validation errors.
    if(typeof bet == "undefined"){
      $scope.messages = "Please choose an option";
      // return;
    }
    else if(typeof bet.option == "undefined"){
      $scope.messages = "Please choose an option";
      // return;
    } else if(!bet.bid) {
      $scope.messages = "Please bid a valid amount";
      // return;
    } else if(bet.bid == 0){
      $scope.messages = "Please bid a positive amount";
      // return;
    } else{             
      // Default values for the request.
      //console.log($rootScope.bids[$stateParams.eventId]);
    if(typeof $rootScope.bids[$stateParams.eventId] == "undefined"){
      bid_id = null;      
    }else{
      bid_id = $rootScope.bids[$stateParams.eventId].id;
    }
    var config = {
      params : {
        'callback' : 'JSON_CALLBACK',
        'option' : bet.option,
        'bid' : bet.bid,
        'event_id'   : $stateParams.eventId,
        'user_id' : $rootScope.uid,
        'bid_id' : bid_id
      },
    };    
    // Perform JSONP request.
    var $promise = $http.jsonp(apihost+'/bids/add', config)
      .success(function(data, status, headers, config) {
        if (data.success) {
            var bidObject = {id:data.bidId,team:bet.option,bid:bet.bid,multiplier:$scope.odds[$stateParams.eventId][bet.option]+1};
            var eventBidObject = new Object();
            eventBidObject[$stateParams.eventId] = bidObject;
            // if(typeof $rootScope.bids[$stateParams.eventId] == "undefined"){
              $rootScope.bids[$stateParams.eventId] = bidObject;
            // }  
            try{
              app.TrackButtonClicked('Bet', $scope.teams[bet.option].name, localStorageService.get('fb_id'));
              $window.mixpanel.track("betonmatch", {
                'event_id':$stateParams.eventId,'option':$scope.teams[bet.option].name,'amount':bet.bid
              }); 
            } catch(e){
              console.log(e.message);
            }   
            if(typeof data.relatedQuestion != 'undefined') {
              if(data.relatedQuestion.length > 0){
                localStorageService.set('relatedbets-'+$stateParams.eventId,data.relatedQuestion);
                localStorageService.set('relatedbetleagueId',data.leagueId);
                var path = 'app.relatedbets';
                $state.go(path,{eventId:$stateParams.eventId});
              }
            }
            var i = 0;
            for(var i in eventlist) {
              var j = parseInt(i)+1;
              if(eventlist[i] == $stateParams.eventId && typeof eventlist[j] != 'undefined'){
                $location.path('/app/playlists/'+eventlist[j]);
                break;
              }
            }
            $rootScope.userCash = data.userCash;
            $scope.messages = data.message;
            $scope.betplaced = true;
            $scope.submitted = false;
          // });
        } else {
          $scope.messages = data.message;
        }
      })
      .error(function(data, status, headers, config) {
        $scope.progress = data;
        $scope.messages = 'There was a network error. Try again later.';
        console.log(data);
      })
      .finally(function() {
        // Hide status messages after three seconds.
        $timeout(function() {
          $scope.messages = null;
        }, 3000);
      });
      // Track the request and show its progress to the user.
      $scope.progress.addPromise($promise);
    }      
  } 
})

.controller('ProfileCtrl', function($scope,$window) {
  $scope.levels = $window.levels;
})

.controller('OfferwallCtrl', function($scope,$window,localStorageService,$rootScope) {
  $scope.uuid = localStorageService.get('uuid');  
})

.controller('TeamStatsCtrl', function($scope,Teamstats,$stateParams) {
  Teamstats.get ({id:$stateParams.eventId},
    function( result ) {   
      $scope.teamstats = result;
      try{
        app.PageButtonClicked("TeamStats - "+$scope.teamstats.schedule.HomeTeam.name+" - "+$scope.teamstats.schedule.AwayTeam.name);
        app.addBanner();
      }catch(e){
        console.log(e.message);
      }
    },
    function( error ) {
      $scope.message = "Something went wrong. Try again later!";
    }
  );  
})

.controller('BankCtrl', function($scope,$rootScope,Bank,BankDeposit,BankWithdraw,BankLoan,BankLoanRepay,localStorageService,$window) {  
  localStorageService.remove('eventlist');
  $scope.$on('$stateChangeSuccess', function() {
    $scope.messages = null;
    try{
      app.PageButtonClicked("Bank");
      app.addBanner();
    }catch(e){
      console.log(e.message);
    }
    Bank.get ({userid: localStorageService.get('fb_id')},
      function( result ) {            
        $scope.bankBalance = result.bankBalance;
        $scope.bankLoan = result.bankLoan;      
        $rootScope.userCash = result.userCash;
        $rootScope.level = result.level;
      },
      function( error ) {
        $scope.messages = "Network Error. Please try later";
      }
    );
  });
  $scope.deposit = function(bank){
    if(typeof bank == "undefined"){
      $scope.messages = "Please enter amount";
    }
    else if(typeof bank.amount == "undefined" || bank.amount == null){
      $scope.messages = "Please enter a valid amount";
    }else{
      try{
        app.TrackButtonClicked('Bank', 'deposit', localStorageService.get('fb_id'));
        $window.mixpanel.track("bank", {
          'type':'deposit','amount': bank.amount
        }); 
      } catch(e){
        console.log(e.message);
      }
      BankDeposit.deposit ({userid: localStorageService.get('fb_id'),amount: bank.amount},
        function( result ) {            
          $scope.messages = result.message;
          if(result.success){
            $rootScope.userCash -= parseInt(result.amount);
          }
        },
        function( error ) {
          $scope.messages = "Network Error. Please try later";
        }
      );
    }
  },
  $scope.withdraw = function(bank){
    if(typeof bank == "undefined"){
      $scope.messages = "Please enter amount";
    }
    else if(typeof bank.amount == "undefined" || bank.amount == null){
      $scope.messages = "Please enter a valid amount";
    }else{
      try{
        app.TrackButtonClicked('Bank', 'withdraw', localStorageService.get('fb_id'));
        $window.mixpanel.track("bank", {
          'type':'withdraw','amount': bank.amount
        }); 
      } catch(e){
        console.log(e.message);
      }
      BankWithdraw.withdraw ({userid: localStorageService.get('fb_id'),amount: bank.amount},
        function( result ) {            
          $scope.messages = result.message;
          if(result.success){
            $rootScope.userCash = parseInt($rootScope.userCash) + parseInt(result.amount);
          }
        },
        function( error ) {
          $scope.messages = "Network Error. Please try later";
        }
      );
    }
  },
  $scope.loan = function(bank){
    if(typeof bank == "undefined"){
      $scope.messages = "Please enter amount";
    }
    else if(typeof bank.amount == "undefined" || bank.amount == null){
      $scope.messages = "Please enter a valid amount";
    }else{
      try{
        app.TrackButtonClicked('Bank', 'loan', localStorageService.get('fb_id'));
        $window.mixpanel.track("bank", {
          'type':'loan','amount': bank.amount
        }); 
      } catch(e){
        console.log(e.message);
      }
      BankLoan.loan ({userid: localStorageService.get('fb_id'),amount: bank.amount},
        function( result ) {            
          $scope.messages = result.message;
          if(result.success){
            $rootScope.userCash = parseInt($rootScope.userCash) + parseInt(result.amount);
          }
        },
        function( error ) {
          $scope.messages = "Network Error. Please try later";
        }
      );
    }
  },
  $scope.repay = function(bank){
    if(typeof bank == "undefined"){
      $scope.messages = "Please enter amount";
    }
    else if(typeof bank.amount == "undefined" || bank.amount == null){
      $scope.messages = "Please enter a valid amount";
    }else{
      try{
        app.TrackButtonClicked('Bank', 'repay', localStorageService.get('fb_id'));
        $window.mixpanel.track("bank", {
          'type':'repay','amount': bank.amount
        }); 
      } catch(e){
        console.log(e.message);
      }
      BankLoanRepay.repayloan ({userid: localStorageService.get('fb_id'),amount: bank.amount},
        function( result ) {            
          $scope.messages = result.message;
          if(result.success){
            $rootScope.userCash -= parseInt(result.amount);
          }
        },
        function( error ) {
          $scope.messages = "Network Error. Please try later";
        }
      );
    }
  }
})

.controller('MemberCtrl', function($scope,$stateParams,$rootScope,localStorageService,Member,Level,$window,$ionicLoading,appid,apihost,Invite,UserProfile) {
    $scope.teams = $window.teams;
    $scope.uid = $stateParams.id;
    $scope.fb_id = $rootScope.getFbId();
    $scope.apihost = apihost;
    $scope.message = null;
    $scope.changeName = function(name){
      UserProfile.set ({uid:$stateParams.id,screenname:name},
        function( result ) {            
          $scope.message = result.message;
        },
        function( error ) {
          $scope.message = "Something went wrong!";
        }
      );   
    },
    $scope.levelupdate = function(action) {
      try{
        app.TrackButtonClicked('Level', action, localStorageService.get('fb_id'));        
      } catch(e){
        console.log(e.message);
      }
      $ionicLoading.show({
        template: 'Loading...'
      });
      Level.update ({id: $stateParams.id,action:action,level:$scope.member.user.User.level},
        function( result ) {            
          $ionicLoading.hide();
          if(result.success){
            $scope.member.user.User.level = result.level;
            $rootScope.level = result.level;
            if(action=='up'){
              $rootScope.userCash = parseInt($rootScope.userCash) - parseInt(result.cost);
            }else{
              $rootScope.userCash = parseInt($rootScope.userCash) + parseInt(result.cost);
            }
          }
          $scope.message = result.message;
        },
        function( error ) {
          $ionicLoading.hide();          
          $scope.message = "Something went wrong. Try agan later!"
        }
      ); 
    },    
    $scope.loaduser = function() {
      try{
        app.PageButtonClicked("Member "+$stateParams.id);
        app.addBanner();
      }catch(e){
        console.log(e.message);
      }
      $ionicLoading.show({
        template: 'Loading...'
      });
      Member.get ({id: $stateParams.id},
        function( result ) {            
          $ionicLoading.hide();
          $scope.member = result;
        },
        function( error ) {
          $ionicLoading.hide();
          $scope.message = "Something went wrong!";
        }
      );   
    },
    $scope.$on('$stateChangeSuccess', function() {
      $scope.message = null;
      if(typeof $scope.member == 'undefined') {
        $scope.loaduser();
      }
    });      

  // }
})

.controller('CashCtrl', function($scope,$rootScope,localStorageService,Member,appid,Invite,apihost,$cordovaSocialSharing,$window) {
  try{
    app.PageButtonClicked("Invite "+localStorageService.get('fb_id'));
  }catch(e){
    console.log(e.message);
  }
  $scope.shareit = function() {
    $cordovaSocialSharing.share("Please install Fantasy Betting with my referral code : "+localStorageService.get('refcode'), "Help me in Fantasy Betting", null, "https://play.google.com/store/apps/details?id=com.mastishq.fantasybetting");
  };
  $scope.uid = localStorageService.get('fb_id');
  $scope.appid = appid; 
  $scope.refcode = localStorageService.get('refcode');
  $scope.invitemessage = "Hey Lets Bet! Play the best virtual sports betting app";
  $scope.inviteFriends = function() {
    var url="https://www.facebook.com/dialog/apprequests?app_id="+appid+"&redirect_uri="+apihost+"/apprequests/invite/&message="+$scope.invitemessage;
    ref = window.open(url, '_blank', 'location=yes'); 
    ref.addEventListener('loadstop', function(event) {
      var parser = document.createElement('a');
      parser.href = event.url;             
      var params = parseQueryString(parser.search);            
      if(params['?request']){
        $scope.request = params['?request'];
        ref.close();
      }  
      try{
        app.TrackButtonClicked('Fbinvite', 'click', localStorageService.get('fb_id'));        
      } catch(e){
        console.log(e.message);
      }
    });  
    ref.addEventListener('exit', function(event) {
      if($scope.request){
        Invite.process({user_id: localStorageService.get('fb_id'),request: $scope.request},
          function( result ) {     
            $scope.message = result.message;
            $scope.userCash = result.balance;
            try{
              app.TrackButtonClicked('Fbinvite', 'success', localStorageService.get('fb_id')); 
              $window.mixpanel.track("fbinvite", {
                'type':'success','ids': $scope.request
              });        
            } catch(e){
              console.log(e.message);
            }
          },
          function( error ) {
            $scope.message = "Something went wrong! Please try again later" ;
          }
        );        
      }            
    });   
  }      
})

  .controller('RelatedbetsCtrl', function($scope,$rootScope,$stateParams,localStorageService,$http,apihost,promiseTracker,$ionicSlideBoxDelegate,$window) {
    $scope.eventid = $stateParams.eventId;
    $scope.relatedbets = localStorageService.get('relatedbets-'+$stateParams.eventId);
    $scope.leagueId = localStorageService.get('relatedbetleagueId');
    // $scope.leagueId = $scope.relatedbets['leagueId'];
    $scope.opts = [];
    $scope.updateOdd = function(odd) {
      $scope.eventodds = Math.round(100/$scope.opts[odd]['odd']);
    }
    $scope.getClassName = function() {
      for(var i in $window.leagues){      
        if(parseInt($window.leagues[i].id) == parseInt($scope.leagueId)) {
          return $window.leagues[i].class;
        }
      }
    }
    for(var i in $scope.relatedbets){
        for(var c in $scope.relatedbets[i].Option){
          $scope.opts[$scope.relatedbets[i].Option[c].id] = $scope.relatedbets[i].Option[c];
        }        
    }
    // console.log("relatedbets "+JSON.stringify($scope.relatedbets));
    // console.log($scope.opts);
    $scope.progress = promiseTracker();
    $scope.submit = function(betval,question_id) {   
      // console.log(betval);
      // console.log(question_id);
      // Trigger validation flag.
      $scope.submitted = true;
      // If form is invalid, return and let AngularJS show validation errors.
      if(typeof betval == "undefined"){
        $scope.messages = "Please choose an option";
        // return;
      }
      else if(typeof betval.option == "undefined"){
        $scope.messages = "Please choose an option";
        // return;
      } else if(!betval.amount) {
        $scope.messages = "Please bid a valid amount";
        // return;
      } else if(betval.amount == 0){
        $scope.messages = "Please bid a positive amount";
        // return;
      } else {       
        try{
          app.TrackButtonClicked('Question', betval.option, localStorageService.get('fb_id'));          
        } catch(e){
          console.log(e.message);
        }
        
        var config = {
          params : {
            'callback' : 'JSON_CALLBACK',
            'option' : betval.option,
            'amount' : betval.amount,
            'question_id'   : question_id,
            'user_id' : localStorageService.get('fb_id'),
            // 'bid_id' : bid_id
          },
        };    
        // Perform JSONP request.
        var $promise = $http.jsonp(apihost+'/questions/bet', config)
          .success(function(data, status, headers, config) {
            if (data.success) {
                // var bidObject = {id:data.bidId,team:bet.option,bid:bet.bid,multiplier:$scope.odds[$stateParams.eventId][bet.option]+1};
                $rootScope.userCash = data.userCash;
                $scope.messages = data.message;
                $scope.betplaced = true;
                $scope.submitted = false;
                $ionicSlideBoxDelegate.next();
                try{
                  $window.mixpanel.track("betonquestion", {
                    'question':question_id,'option':$scope.opts[betval.option]['option'],'amount':betval.amount,'screen':'relatedbets'
                  }); 
                } catch(e){
                  console.log(e.message);
                }
            } else {
              $scope.messages = data.message;
            }
          })
          .error(function(data, status, headers, config) {
            $scope.progress = data;
            $scope.messages = 'There was a network error. Try again later.';
            // console.log(data);
          })
          .finally(function() {
            // Hide status messages after three seconds.
            $timeout(function() {
              $scope.messages = null;
            }, 3000);
          });
        // Track the request and show its progress to the user.
        $scope.progress.addPromise($promise);
      }      
    } 
  })

.controller('OtherbetsCtrl', function($scope,$rootScope,$stateParams,localStorageService,$http,apihost,promiseTracker,$ionicSlideBoxDelegate,Questions,$ionicLoading,$window) {
    var elems = document.getElementsByClassName('relatedbet');
    $scope.messages = '';
    // console.log(elems[0]);
    // .style.height = 900px;
    $scope.apihost = apihost;
    $scope.curpage = 1;
    $scope.maxpages = 20;
    $scope.relatedbets = [];
    $scope.opts = [];
    $scope.updateOdd = function(odd) {
      $scope.eventodds = Math.round(100/$scope.opts[odd]['odd']);
    }
    $scope.getClassName = function() {
      for(var i in $window.leagues){      
        if(parseInt($window.leagues[i].id) == parseInt($scope.leagueId)) {
          return $window.leagues[i].class;
        }
      }
    }
    $scope.loadmore = function () {    
      try{
        app.PageButtonClicked("Questions "+$scope.curpage);
        app.addBanner();
      }catch(e){
        console.log(e.message);
      }
      // console.log('Fetch leaders page '+$scope.curpage);
      $ionicLoading.show({
        template: 'Loading...'
      });
      setTimeout(function(){ $ionicLoading.hide(); }, 5000);
      Questions.get ({user_id: localStorageService.get('fb_id'),page: $scope.curpage},
        function( result ) {     
          $ionicLoading.hide();       
          $scope.leagueId = result.questions[0]['Schedule']['leagueid'];
          // console.log($scope.leagueId);
          for(var i in result.questions){
            $scope.relatedbets.push(result.questions[i]);          
          }               
          // $scope.relatedbets = result.questions;
          for(var i in $scope.relatedbets){
              for(var c in $scope.relatedbets[i].Option){
                $scope.opts[$scope.relatedbets[i].Option[c].id] = $scope.relatedbets[i].Option[c];                
              }        
          }
          $ionicSlideBoxDelegate.update();
        },
        function( error ) {
          $ionicLoading.hide();     
          // $scope.messages = "Something went wrong!";
        }
      );
      $scope.curpage++;
      // $scope.$broadcast('scroll.infiniteScrollComplete');                               
    },  
    $scope.moreDataCanBeLoaded = function() {
      if($scope.curpage <= $scope.maxpages)
        return true;
      return false;
    },
    $scope.$on('$stateChangeSuccess', function() {
      if(typeof $scope.relatedbets != 'undefined') {
        $scope.loadmore();
      }
    });
    $scope.slideHasChanged = function(index){
      // console.log(index);
      if(index >= $scope.relatedbets.length-1){
        $scope.loadmore();
      }
    }    

    $scope.progress = promiseTracker();
    $scope.submit = function(betval,question_id) {   
      console.log(betForm.$error);
      // console.log(question_id);
      // Trigger validation flag.
      $scope.submitted = true;
      // If form is invalid, return and let AngularJS show validation errors.
      if(typeof betval == "undefined"){
        $scope.messages = "Please choose an option";
        // return;
      }
      else if(typeof betval.option == "undefined"){
        $scope.messages = "Please choose an option";
        // return;
      } else if(!betval.amount) {
        $scope.messages = "Please bid a valid amount";
        // return;
      } else if(betval.amount == 0){
        $scope.messages = "Please bid a positive amount";
        // return;
      } else {       
        try{
          app.TrackButtonClicked('Question', betval.option, localStorageService.get('fb_id'));          
        } catch(e){
          console.log(e.message);
        }
        
        var config = {
          params : {
            'callback' : 'JSON_CALLBACK',
            'option' : betval.option,
            'amount' : betval.amount,
            'question_id'   : question_id,
            'user_id' : localStorageService.get('fb_id'),
            // 'bid_id' : bid_id
          },
        };    
        // Perform JSONP request.
        var $promise = $http.jsonp(apihost+'/questions/bet', config)
          .success(function(data, status, headers, config) {
            if (data.success) {
                // var bidObject = {id:data.bidId,team:bet.option,bid:bet.bid,multiplier:$scope.odds[$stateParams.eventId][bet.option]+1};
                $rootScope.userCash = data.userCash;
                $scope.messages = data.message;
                $scope.betplaced = true;
                $scope.submitted = false;
                // console.log($ionicSlideBoxDelegate.slidesCount());
                // console.log($ionicSlideBoxDelegate.currentIndex());
                try{
                  $window.mixpanel.track("betonquestion", {
                    'question':question_id,'option':$scope.opts[betval.option]['option'],'amount':betval.amount,'screen':'otherbets'
                  }); 
                } catch(e) {
                  console.log(e);
                }
                if($ionicSlideBoxDelegate.currentIndex()<$ionicSlideBoxDelegate.slidesCount()){
                  $ionicSlideBoxDelegate.next();
                } else{
                  $scope.loadmore();
                }
              // });
            } else {
              $scope.messages = data.message;
            }
          })
          .error(function(data, status, headers, config) {
            $scope.progress = data;
            $scope.messages = 'There was a network error. Try again later.';
            // console.log(data);
          })
          .finally(function() {
            // Hide status messages after three seconds.
            $timeout(function() {
              $scope.messages = null;
            }, 3000);
          });
        // Track the request and show its progress to the user.
        $scope.progress.addPromise($promise);
      }      
    } 
  })

  .controller('LeadersCtrl', function($scope,$rootScope,localStorageService,Leaders,$ionicLoading,apihost,Locate,$ionicScrollDelegate) {    
    $scope.apihost = apihost;
    $scope.curpage = 1;
    $scope.maxpages = 20;
    $scope.leaders = [];
    $scope.locateme = function() {
      $ionicLoading.show({
        template: 'Loading...'
      });
      setTimeout(function(){ $ionicLoading.hide(); }, 5000);
      Locate.me ({uid: localStorageService.get('fb_id')},
        function( result ) {     
          $ionicLoading.hide();       
          $scope.maxpages = result.maxpages;
          $scope.curpage = result.page+1;
          // $scope.leaders = null;
          for(var i in result.leaders){
            $scope.leaders.push(result.leaders[i]);          
          }
          $scope.$broadcast('scroll.refreshComplete');
          $ionicScrollDelegate.scrollBottom();
        },
        function( error ) {
          console.log( "Something went wrong!" );
          $ionicLoading.hide();       
        }
      );
      try{
        app.TrackButtonClicked('Locateme', 'click', localStorageService.get('fb_id'));
        $window.mixpanel.track("locateme", {
          'from_page':$scope.curpage
        }); 
      } catch(e){
        console.log(e.message);
      }
    }
    $scope.loadmore = function () {    
      try{
        app.PageButtonClicked("Leaders "+$scope.curpage);
      }catch(e){
        console.log(e.message);
      }
      // console.log('Fetch leaders page '+$scope.curpage);
      $ionicLoading.show({
        template: 'Loading...'
      });
      setTimeout(function(){ $ionicLoading.hide(); }, 5000);
      Leaders.get ({page: $scope.curpage},
        function( result ) {     
          $ionicLoading.hide();       
          $scope.maxpages = result.maxpages;
          for(var i in result.leaders){
            $scope.leaders.push(result.leaders[i]);          
          }
        },
        function( error ) {
          console.log( "Something went wrong!" );
        }
      );
      $scope.curpage++;
      $scope.$broadcast('scroll.infiniteScrollComplete');                               
    },  
    $scope.moreDataCanBeLoaded = function() {
      if($scope.curpage <= $scope.maxpages)
        return true;
      return false;
    },
    $scope.$on('$stateChangeSuccess', function() {
      if(typeof $scope.leaders != 'undefined') {
        $scope.loadmore();
      }
    });
  });