/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
var pushNotification;
var gaPlugin;
var curpage = 1;

var app = {
    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },
    
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        // document.addEventListener('load', this.onLoad, false);
        document.addEventListener('deviceready', this.onDeviceReady, false);
        document.addEventListener('onAdmobInterstitialReceive', this.onInterstitialReceive, false);
        document.addEventListener('onAdmobBannerReceive', this.onAdmobEventReceive, false);        
    },

    onLoad: function() {
        console.log("On load");        
    },
   
    // deviceready Event Handler
    onDeviceReady: function() {        
        // app.addBanner();
        app.addInterstitial();
           
        try{
            var customLocale = {};
            customLocale.title = "Rate Fantasy Betting Game";
            customLocale.message = "If you enjoy playing Fantasy Betting Game, would you mind taking a moment to rate it? It won’t take more than a minute. Thanks for your support!";
            customLocale.cancelButtonLabel = "No, Thanks";
            customLocale.laterButtonLabel = "Remind Me Later";
            customLocale.rateButtonLabel = "Rate It Now";

            AppRate.preferences.openStoreInApp = true;
            AppRate.preferences.storeAppURL.android = 'market://details?id=com.mastishq.fantasybetting';
            AppRate.preferences.customLocale = customLocale;
            AppRate.preferences.displayAppName = 'Fantasy Betting Game';
            AppRate.preferences.usesUntilPrompt = 5;
            AppRate.preferences.promptAgainForEachNewVersion = false;
            AppRate.promptForRating();
        } catch(err){
            console.log(err);
        }        
        try{
            gaPlugin = window.plugins.gaPlugin;
            gaPlugin.init(this.gaSuccessHandler, this.gaErrorHandler, "UA-57401660-6", 10);
        } catch(err){
            console.log(err);
        }
    },

    gaSuccessHandler: function(result){
        console.log('gaSuccessHandler: '+result);
    },

    gaErrorHandler: function(result){
      console.log('gaErrorHandler: '+result);  
    },

    TrackButtonClicked: function(category,label,value) {
        gaPlugin.trackEvent( this.gaSuccessHandler, this.gaErrorHandler, category, "Click", label, value);
    },

    PageButtonClicked: function(page) {
        gaPlugin.trackPage( this.gaSuccessHandler, this.gaErrorHandler, page);
    },

    SetVariable: function(variable,value){
        switch(variable){
            case 'userid':
                var index = 1;
                break;
            case 'username':
                var index = 2;
                break;
            case 'appversion':
                var index = 3;
                break;                
        }
        gaPlugin.setVariable( this.gaSuccessHandler, this.gaErrorHandler, index, value);
    },

    onInterstitialReceive:  function(message) {
        console.log('display Interstitial ads '+message);        
        admobAd.showInterstitial();//show Interstitial after receive or after game over        
    },

    onAdmobEventReceive: function (message) {
        console.log('display Banner ads '+message);        
        console.log('receive admob  Event: ' + message.type);
    },   

    addBanner: function () {
        var successCreateBannerView = function () {
            admobAd.showBanner(admobAd.AD_POSITION.BOTTOM_CENTER);
            console.log('show banner at bottom');        
        };
        var errorCreateBannerView = function (message) {
            console.log("create banner fail " + message);
        };
        admobAd.initBanner("ca-app-pub-2954202814689324/9768458488", admobAd.AD_SIZE.BANNER.width, admobAd.AD_SIZE.BANNER.height, successCreateBannerView, errorCreateBannerView);
    },

    addInterstitial: function () {
        var successCreateInterstitial = function () {
            admobAd.cacheInterstitial();
        };
        admobAd.initInterstitial("ca-app-pub-2954202814689324/2062554086", successCreateInterstitial);
    },

    showInterstitial: function () {
        var isReadySuccess = function (isReady) {
            if (isReady) {
                admobAd.showInterstitial();
            } else {
                admobAd.cacheInterstitial();
            }
        };
        admobAd.isInterstitialReady(isReadySuccess);
    },

    disposePlugin: function () {
        admobAd.disposePlugin();
    } 
};

function parseQueryString( queryString ) {
    var params = {}, queries, temp, i, l;     
    // Split into key/value pairs
    queries = queryString.split("&");     
    // Convert the array of strings into an object
    for ( i = 0, l = queries.length; i < l; i++ ) {
        temp = queries[i].split('=');
        params[temp[0]] = temp[1];
    }     
    return params;
};