// Simple value service.
angular.module('starter.services', [])
    .value('version', '0.1')
    .factory('UserProfile', function($resource,apihost) {
        return $resource(apihost+"/users/updatename/:uid/:screenname",
            {callback: "JSON_CALLBACK"} , 
            { set: {
                method: "JSONP",
               }
            }
        )})
     .factory('Teamstats', function($resource,apihost) {
        return $resource(apihost+"/teamstats/view/:id",
            {callback: "JSON_CALLBACK"} , 
            { get: {
                method: "JSONP",
               }
            }
        )})
    .factory('Auth', function($resource,apihost) {
        return $resource(apihost+"/users/authenticate/:email/:password/:refcode",
            {callback: "JSON_CALLBACK"} , 
            { authenticate: {
                method: "JSONP",
               }
            }
        )})     
    .factory('Mystats', function($resource,apihost) {
        return $resource(apihost+"/stats/mine/:user_id/:access_token/:email/:name/:password/:uuid",
            {callback: "JSON_CALLBACK"} , 
            { get: {
                method: "JSONP",
               }
            }
        )})     
    .factory('Teams', function($resource,apihost) {
        return $resource(apihost+"/teams/index/page:"+":page",
            {callback: "JSON_CALLBACK"} , 
            { get: {
                method: "JSONP",
               }
            }
        )}) 
    .factory('Leaders', function($resource,apihost) {
        return $resource(apihost+"/leaders/index/page:"+":page",
            {callback: "JSON_CALLBACK"} , 
            { get: {
                method: "JSONP",
               }
            }
        )})
    .factory('Locate', function($resource,apihost) {
        return $resource(apihost+"/leaders/locateme/:uid",
            {callback: "JSON_CALLBACK"} , 
            { me: {
                method: "JSONP",
               }
            }
        )})
    .factory('Jackpot', function($resource,apihost) {
        return $resource(apihost+"/jackpots/claim/:uid",
            {callback: "JSON_CALLBACK"} , 
            { claim: {
                method: "JSONP",
               }
            }
        )})         
    .factory('Questions', function($resource,apihost) {
        // return $resource(apihost+"/questions/index/page:"+":page?user_id=user_id",
        return $resource(apihost+"/questions/index/:user_id/page:"+":page",
            {callback: "JSON_CALLBACK"} , 
            { get: {
                method: "JSONP",
               }
            }
        )})   
    .factory('Level', function($resource,apihost) {
        return $resource(apihost+"/levels/update/"+":id/:action/:level",
            {callback: "JSON_CALLBACK"} , 
            { update: {
                method: "JSONP",
               }
            }
        )})   
    .factory('Member', function($resource,apihost) {
        return $resource(apihost+"/leaders/view/"+":id",
            {callback: "JSON_CALLBACK"} , 
            { get: {
                method: "JSONP",
               }
            }
        )})  
    .factory('Bank', function($resource,apihost) {
        return $resource(apihost+"/banks/index/get/"+":userid",
            {callback: "JSON_CALLBACK"}, 
            { get: {
                method: "JSONP",
               }
            }
        )})  
    .factory('BankDeposit', function($resource,apihost) {
        return $resource(apihost+"/banks/index/deposit/"+":userid/:amount",
            {callback: "JSON_CALLBACK"}, 
            { deposit: {
                method: "JSONP",
               }
            }
        )})    
    .factory('BankWithdraw', function($resource,apihost) {
        return $resource(apihost+"/banks/index/withdraw/"+":userid/:amount",
            {callback: "JSON_CALLBACK"}, 
            { withdraw: {
                method: "JSONP",
               }
            }
        )})
    .factory('BankLoan', function($resource,apihost) {
        return $resource(apihost+"/banks/index/loan/"+":userid/:amount",
            {callback: "JSON_CALLBACK"}, 
            { loan: {
                method: "JSONP",
               }
            }
        )})
    .factory('BankLoanRepay', function($resource,apihost) {
        return $resource(apihost+"/banks/index/repay/"+":userid/:amount",
            {callback: "JSON_CALLBACK"}, 
            { repayloan: {
                method: "JSONP",
               }
            }
        )})    
    .factory('Schedules', function($resource,apihost) {        
        return $resource(apihost+"/schedules/index/:user_id/:league_id/page:"+":page",
            {callback: "JSON_CALLBACK"} , 
            { get: {
                method: "JSONP",
               }
            }
        )})     
    .factory('Invite', function($resource,apihost) {        
        return $resource(apihost+"/apprequests/process/:user_id/:request",
            {callback: "JSON_CALLBACK"} , 
            { process: {
                method: "JSONP",
               }
            }
        )})    
    .value('apihost',"http://api.heyletsbet.com")
    .value('baseUrl',"http://heyletsbet.com")
    .value('appid','860704380618102')
    .value('hangouttapihost','https://api.hangoutt.com/')
    .value('hangouttclientid','550380anikendra@gmail.com')
    .value('hangouttsecret','4487def64a20ffaf268543f8097f589a315e6b22')

// phonegap ready service - listens to deviceready
.factory('phonegapReady', function() {
    return function (fn) {
        var queue = [];
        var impl = function () {
        queue.push(Array.prototype.slice.call(arguments));
    };
              
    document.addEventListener('deviceready', function () {
        queue.forEach(function (args) {
            fn.apply(this, args);
        });
        impl = fn;
    }, false);
              
    return function () {
        return impl.apply(this, arguments);
        };
    };
})

.factory('notification', function ($rootScope, phonegapReady) {
    return {
        alert: phonegapReady(function (message, alertCallback, title, buttonName) {
            navigator.notification.alert(message, function () {
                var that = this,
                    args = arguments;

                $rootScope.$apply(function () {
                    alertCallback.apply(that, args);
                });
            }, title, buttonName);
        }),
        confirm: phonegapReady(function (message, confirmCallback, title, buttonLabels) {
            navigator.notification.confirm(message, function () {
                var that = this,
                    args = arguments;

                $rootScope.$apply(function () {
                    confirmCallback.apply(that, args);
                });
            }, title, buttonLabels);
        }),
        beep: function (times) {
            navigator.notification.beep(times);
        },
        vibrate: function (milliseconds) {
            navigator.notification.vibrate(milliseconds);
        }
    };
})

.factory('navSvc', function($navigate) {
    return {
        slidePage: function (path,type) {
            $navigate.go(path,type);
        },
        back: function () {
            $navigate.back();
        }
    }
})

.factory(
    "transformRequestAsFormPost",
    function() {

        // I prepare the request data for the form post.
        function transformRequest( data, getHeaders ) {

            var headers = getHeaders();

            headers[ "Content-type" ] = "application/x-www-form-urlencoded; charset=utf-8";

            return( serializeData( data ) );

        }


        // Return the factory value.
        return( transformRequest );


        // ---
        // PRVIATE METHODS.
        // ---


        // I serialize the given Object into a key-value pair string. This
        // method expects an object and will default to the toString() method.
        // --
        // NOTE: This is an atered version of the jQuery.param() method which
        // will serialize a data collection for Form posting.
        // --
        // https://github.com/jquery/jquery/blob/master/src/serialize.js#L45
        function serializeData( data ) {

            // If this is not an object, defer to native stringification.
            if ( ! angular.isObject( data ) ) {

                return( ( data == null ) ? "" : data.toString() );

            }

            var buffer = [];

            // Serialize each key in the object.
            for ( var name in data ) {

                if ( ! data.hasOwnProperty( name ) ) {

                    continue;

                }

                var value = data[ name ];

                buffer.push(
                    encodeURIComponent( name ) +
                    "=" +
                    encodeURIComponent( ( value == null ) ? "" : value )
                );

            }

            // Serialize the buffer and clean it up for transportation.
            var source = buffer
                .join( "&" )
                .replace( /%20/g, "+" )
            ;

            return( source );

        }

    }
);